diff -urN memcached-1.4.13/t.rep/23-replace-exptime.t memcached-1.4.13-repcached-2.3.1/t.rep/23-replace-exptime.t
--- memcached-1.4.13/t.rep/23-replace-exptime.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/23-replace-exptime.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,32 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('replacetest'.$uniq, 'setval_replace'.$uniq);
+    my $vallen = length $val;
+
+    print $sock_m "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+
+    my $exptime = 2;
+    my $val2    = 'replaceval'.$uniq;
+    my $vallen2 = length $val2;
+
+    print $sock_m "replace $key 0 $exptime $vallen2\r\n$val2\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val2);
+    sleep $exptime+2;
+    sync_get_is($sock_m, $sock_b, $key, undef)
+}
diff -urN memcached-1.4.13/t.rep/24-touch.t memcached-1.4.13-repcached-2.3.1/t.rep/24-touch.t
--- memcached-1.4.13/t.rep/24-touch.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/24-touch.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,34 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('settest'.$uniq, 'setval'.$uniq);
+    my $vallen = length $val;
+
+    my $exptime = 4;
+
+    print $sock_m "set $key 0 $exptime $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+    sleep 2;
+    print $sock_m "touch $key $exptime\r\n";
+    is(scalar <$sock_m>, "TOUCHED\r\n", "touched 1");
+    sleep 2;
+    print $sock_m "touch $key $exptime\r\n";
+    is(scalar <$sock_m>, "TOUCHED\r\n", "touched 2");
+    sleep 2;
+    sync_get_is($sock_m, $sock_b, $key, $val);
+    sleep $exptime+1;
+    sync_get_is($sock_m, $sock_b, $key, undef)
+}
diff -urN memcached-1.4.13/t.rep/31-delete.t memcached-1.4.13-repcached-2.3.1/t.rep/31-delete.t
--- memcached-1.4.13/t.rep/31-delete.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/31-delete.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,26 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('deletetest'.$uniq, 'deleteval'.$uniq);
+    my $vallen = length $val;
+
+    print $sock_m "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+
+    print $sock_m "delete $key\r\n";
+    is(scalar <$sock_m>, "DELETED\r\n", "deleted");
+    sync_get_is($sock_m, $sock_b, $key, undef)
+}
diff -urN memcached-1.4.13/t.rep/41-incrdecr.t memcached-1.4.13-repcached-2.3.1/t.rep/41-incrdecr.t
--- memcached-1.4.13/t.rep/41-incrdecr.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/41-incrdecr.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,74 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my $version     = memcached_version();
+my $version_num = version2num($version);
+my $support_overflow = $version_num >= version2num('1.2.4') ? 1 : 0;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    print $sock_m "set num 0 0 1\r\n1\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored num");
+    sync_get_is($sock_m, $sock_b, "num", 1, "stored 1");
+
+    print $sock_m "incr num 1\r\n";
+    is(scalar <$sock_m>, "2\r\n", "+ 1 = 2");
+    sync_get_is($sock_m, $sock_b, "num", 2);
+
+    print $sock_m "incr num 8\r\n";
+    is(scalar <$sock_m>, "10\r\n", "+ 8 = 10");
+    sync_get_is($sock_m, $sock_b, "num", 10);
+
+    print $sock_m "decr num 1\r\n";
+    is(scalar <$sock_m>, "9\r\n", "- 1 = 9");
+    #sync_get_is($sock_m, $sock_b, "num", '9 ');
+    sync_get_is($sock_m, $sock_b, "num", '9');
+
+    print $sock_m "decr num 9\r\n";
+    is(scalar <$sock_m>, "0\r\n", "- 9 = 0");
+    #sync_get_is($sock_m, $sock_b, "num", '0 ');
+    sync_get_is($sock_m, $sock_b, "num", '0');
+
+    print $sock_m "decr num 5\r\n";
+    is(scalar <$sock_m>, "0\r\n", "- 5 = 0");
+    #sync_get_is($sock_m, $sock_b, "num", '0 ');
+    sync_get_is($sock_m, $sock_b, "num", '0');
+
+    printf $sock_m "set num 0 0 10\r\n4294967296\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored 2**32");
+
+    if ($support_overflow) {
+        print $sock_m "incr num 1\r\n";
+        is(scalar <$sock_m>, "4294967297\r\n", "4294967296 + 1 = 4294967297");
+        sync_get_is($sock_m, $sock_b, "num", 4294967297);
+
+        printf $sock_m "set num 0 0 %d\r\n18446744073709551615\r\n", length("18446744073709551615");
+        is(scalar <$sock_m>, "STORED\r\n", "stored 2**64-1");
+        sync_get_is($sock_m, $sock_b, "num", '18446744073709551615');
+
+        print $sock_m "incr num 1\r\n";
+        is(scalar <$sock_m>, "0\r\n", "(2**64 - 1) + 1 = 0");
+        #sync_get_is($sock_m, $sock_b, "num", sprintf('%-20s','0'));
+        sync_get_is($sock_m, $sock_b, "num", '0');
+    }
+
+    print $sock_m "decr bogus 5\r\n";
+    is(scalar <$sock_m>, "NOT_FOUND\r\n", "can't decr bogus key");
+
+    print $sock_m "decr incr 5\r\n";
+    is(scalar <$sock_m>, "NOT_FOUND\r\n", "can't incr bogus key");
+
+    print $sock_m "set text 0 0 2\r\nhi\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored text");
+    print $sock_m "incr text 1\r\n";
+    like(scalar <$sock_m>, qr/CLIENT_ERROR/, "hi - 1 = error");
+}
diff -urN memcached-1.4.13/t.rep/51-flush-all.t memcached-1.4.13-repcached-2.3.1/t.rep/51-flush-all.t
--- memcached-1.4.13/t.rep/51-flush-all.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/51-flush-all.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,33 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    print $sock_m "set foo 0 0 6\r\nfooval\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored foo");
+    sync_get_is($sock_m, $sock_b, "foo", "fooval");
+
+    print $sock_m "flush_all\r\n";
+    is(scalar <$sock_m>, "OK\r\n", "did flush_all");
+    sync_get_is($sock_m, $sock_b, "foo", undef);
+
+    # and the other form, specifying a flush_all time...
+    my $expire = 4;
+    print $sock_m "flush_all $expire\r\n";
+    is(scalar <$sock_m>, "OK\r\n", "did flush_all in future");
+
+    print $sock_m "set foo 0 0 4\r\n1234\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored foo = '1234'");
+    sync_get_is($sock_m, $sock_b, "foo", '1234');
+    sleep $expire+1;
+    sync_get_is($sock_m, $sock_b, "foo", undef);
+}
diff -urN memcached-1.4.13/t.rep/61-append-prepend.t memcached-1.4.13-repcached-2.3.1/t.rep/61-append-prepend.t
--- memcached-1.4.13/t.rep/61-append-prepend.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/61-append-prepend.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,39 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my $key = 'append-prepend-test'.$uniq;
+    my($prepend, $base, $append) = ('PPP', 'BASE'.$uniq, 'AAA'); #val
+
+    print $sock_m "append $key 0 0 ".length($append)."\r\n$append\r\n";
+    is(scalar <$sock_m>, "NOT_STORED\r\n", "not stored");
+    sync_get_is($sock_m, $sock_b, $key, undef);
+
+    print $sock_m "prepend $key 0 0 ".length($prepend)."\r\n$prepend\r\n";
+    is(scalar <$sock_m>, "NOT_STORED\r\n", "not stored");
+    sync_get_is($sock_m, $sock_b, $key, undef);
+
+
+    print $sock_m "set $key 0 0 ".length($base)."\r\n$base\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+
+
+    print $sock_m "append $key 0 0 ".length($append)."\r\n$append\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $base.$append);
+
+    print $sock_m "prepend $key 0 0 ".length($prepend)."\r\n$prepend\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $prepend.$base.$append);
+}
diff -urN memcached-1.4.13/t.rep/62-cas.t memcached-1.4.13-repcached-2.3.1/t.rep/62-cas.t
--- memcached-1.4.13/t.rep/62-cas.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/62-cas.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,118 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $key  = 'castest';
+    my $val  = 'casval';
+    my $val2 = 'casval2';
+
+    # gets foo (should not exist)
+    print $sock_m "gets $key\r\n";
+    is(scalar <$sock_m>, "END\r\n", "not stored");
+    sync_get_is($sock_m, $sock_b, $key, undef);
+
+    # set foo
+    print $sock_m "set $key 0 0 ".length($val)."\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+
+    # cas fail
+    print $sock_m "cas $key 0 0 ".length($val2)." 123\r\n$val2\r\n";
+    is(scalar <$sock_m>, "EXISTS\r\n", "cas failed for $key");
+
+    # gets foo - success
+    my @result;
+    @result = mem_gets($sock_m, $key);
+    mem_gets_is($sock_m,$result[0],$key,$val);
+
+    @result = mem_gets($sock_b, $key);
+    mem_gets_is($sock_b,$result[0],$key,$val);
+
+    # cas success
+    print $sock_m "cas $key 0 0 ".length($val2)." $result[0]\r\n$val2\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "cas success, set $key");
+    sync_get_is($sock_m, $sock_b, $key, $val2);
+
+    # cas failure (reusing the same key)
+    print $sock_m "cas $key 0 0 ".length($val2)." $result[0]\r\n$val2\r\n";
+    is(scalar <$sock_m>, "EXISTS\r\n", "reusing a CAS ID");
+
+    # delete foo
+    print $sock_m "delete $key\r\n";
+    is(scalar <$sock_m>, "DELETED\r\n", "deleted $key");
+    sync_get_is($sock_m, $sock_b, $key, undef);
+
+    # cas missing
+    print $sock_m "cas $key 0 0 ".length($val2)." $result[0]\r\n$val2\r\n";
+    is(scalar <$sock_m>, "NOT_FOUND\r\n", "cas failed, $key does not exist");
+
+    # cas empty
+    print $sock_m "cas $key 0 0 ".length($val2)." \r\n$val2\r\n";
+    is(scalar <$sock_m>, "ERROR\r\n", "cas empty, throw error");
+    # cant parse barval2\r\n
+    is(scalar <$sock_m>, "ERROR\r\n", "error out on barval2 parsing");
+
+    # set foo1
+    print $sock_m "set foo1 0 0 1\r\n1\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "foo1");
+    sync_get_is($sock_m, $sock_b, 'foo1', '1');
+    # set foo2
+    print $sock_m "set foo2 0 0 1\r\n2\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "foo1");
+    sync_get_is($sock_m, $sock_b, 'foo2', '2');
+
+    # gets foo1 check
+    print $sock_m "gets foo1\r\n";
+    ok(scalar <$sock_m> =~ /VALUE foo1 0 1 (\d+)\r\n/, "gets foo1 regexp success");
+    my $foo1_cas_m = $1;
+    is(scalar <$sock_m>, "1\r\n","gets foo1 data is 1");
+    is(scalar <$sock_m>, "END\r\n","gets foo1 END");
+
+    print $sock_b "gets foo1\r\n";
+    ok(scalar <$sock_b> =~ /VALUE foo1 0 1 (\d+)\r\n/, "gets foo1 regexp success");
+    my $foo1_cas_b = $1;
+    is(scalar <$sock_b>, "1\r\n","gets foo1 data is 1");
+    is(scalar <$sock_b>, "END\r\n","gets foo1 END");
+
+    # gets foo2 check
+    print $sock_m "gets foo2\r\n";
+    ok(scalar <$sock_m> =~ /VALUE foo2 0 1 (\d+)\r\n/,"gets foo2 regexp success");
+    my $foo2_cas_m = $1;
+    is(scalar <$sock_m>, "2\r\n","gets foo2 data is 2");
+    is(scalar <$sock_m>, "END\r\n","gets foo2 END");
+
+    print $sock_b "gets foo2\r\n";
+    ok(scalar <$sock_b> =~ /VALUE foo2 0 1 (\d+)\r\n/,"gets foo2 regexp success");
+    my $foo2_cas_b = $1;
+    is(scalar <$sock_b>, "2\r\n","gets foo2 data is 2");
+    is(scalar <$sock_b>, "END\r\n","gets foo2 END");
+
+    # validate foo1 != foo2
+    ok($foo1_cas_m =  $foo1_cas_b,"foo1  = foo1 between master and backup");
+    ok($foo2_cas_m =  $foo2_cas_b,"foo2  = foo2 between master and backup");
+    ok($foo1_cas_m != $foo2_cas_m,"foo1 != foo2 single-gets success");
+    ok($foo1_cas_b != $foo2_cas_b,"foo1 != foo2 single-gets success");
+
+    # multi-gets
+    print $sock_m "gets foo1 foo2\r\n";
+    ok(scalar <$sock_m> =~ /VALUE foo1 0 1 (\d+)\r\n/, "validating first set of data is foo1");
+    $foo1_cas_m = $1;
+    is(scalar <$sock_m>, "1\r\n",, "validating foo1 set of data is 1");
+    ok(scalar <$sock_m> =~ /VALUE foo2 0 1 (\d+)\r\n/, "validating second set of data is foo2");
+    $foo2_cas_m = $1;
+    is(scalar <$sock_m>, "2\r\n", "validating foo2 set of data is 2");
+    is(scalar <$sock_m>, "END\r\n","validating foo1,foo2 gets is over - END");
+
+    # validate foo1 != foo2
+    ok($foo1_cas_m != $foo2_cas_m, "foo1 != foo2 multi-gets success");
+}
diff -urN memcached-1.4.13/t.rep/71-cpuhog.t memcached-1.4.13-repcached-2.3.1/t.rep/71-cpuhog.t
--- memcached-1.4.13/t.rep/71-cpuhog.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/71-cpuhog.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,50 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+# emulate transient network problems by stopping processes
+# stop second process, fill buffers on first one
+# XXX use (pid + 1) to bypass timedrun, unsafe
+kill 'STOP', $m2->{pid} + 1;
+
+my ($uniq, $key, $val, $vallen);
+
+for my $i (1..1000) {
+    $uniq = int(rand()*100000);
+    $key = 'settest_1_' . $i;
+    $val = 'setval' . ('0' x 1024) . $uniq;
+    $vallen = length $val;
+    print $sock_m1 "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m1>, "STORED\r\n", "stored");
+}
+
+# stop first process, fill buffers on second one
+kill 'STOP', $m1->{pid} + 1;
+kill 'CONT', $m2->{pid} + 1;
+
+for my $i (1..1000) {
+    $uniq = int(rand()*100000);
+    $key = 'settest_2_' . $i;
+    $val = 'setval' . ('0' x 1024) . $uniq;
+    $vallen = length $val;
+    print $sock_m2 "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m2>, "STORED\r\n", "stored");
+}
+
+# release first process
+kill 'CONT', $m1->{pid} + 1;
+
+# wait for a while, as normal sync time may not be enough
+sleep(1);
+
+mem_get_is($sock_m1, $key, $val, "get $key from 1st");
+mem_get_is($sock_m2, $key, $val, "get $key from 2nd");
diff -urN memcached-1.4.13/t.rep/72-shutdown-sync.t memcached-1.4.13-repcached-2.3.1/t.rep/72-shutdown-sync.t
--- memcached-1.4.13/t.rep/72-shutdown-sync.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/72-shutdown-sync.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,43 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+# stop second process, fill buffers on first one
+# XXX use (pid + 1) to bypass timedrun, unsafe
+kill 'STOP', $m2->{pid} + 1;
+
+my ($uniq, $key, $val, $vallen);
+
+for my $i (1..10) {
+    $key = 'settest_1_' . $i;
+    $val = 'setval' . $i . ('0' x (1000*1024));
+    $vallen = length $val;
+    print $sock_m1 "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m1>, "STORED\r\n", "stored $i");
+}
+
+# ask first process to shutdown, and release second one
+kill 'INT', $m1->{pid} + 1;
+kill 'CONT', $m2->{pid} + 1;
+
+# wait for a while
+sleep(2);
+
+for my $i (1..10) {
+    $key = 'settest_1_' . $i;
+    my $expected = 'setval' . $i . ('0' x (1000*1024)) . "\r\nEND\r\n";
+    print $sock_m2 "get $key\r\n";
+    my $r = <$sock_m2>;
+    $r = <$sock_m2> . <$sock_m2> if $r =~ /VALUE/;
+    is(substr($r, 0, 20), substr($expected, 0, 20), "get $i");
+    is(length($r), length($expected), "get $i length");
+}
diff -urN memcached-1.4.13/t.rep/73-cpuhog-pipe.t memcached-1.4.13-repcached-2.3.1/t.rep/73-cpuhog-pipe.t
--- memcached-1.4.13/t.rep/73-cpuhog-pipe.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/73-cpuhog-pipe.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,55 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+# emulate transient network problems by stopping processes
+# stop second process, fill buffers on first one
+# XXX use (pid + 1) to bypass timedrun, unsafe
+kill 'STOP', $m2->{pid} + 1;
+
+my ($uniq, $key, $val, $vallen);
+
+# we should fill send buffer and internal pipe buffer
+# typical 64k pipe buffer on 32-bit platform requires 16k items
+# to be filled (64k / sizeof(void*))
+
+for my $i (1..20000) {
+    $uniq = int(rand()*100000);
+    $key = 'settest_1_' . $i;
+    $val = 'setval' . ('0' x 1024) . $uniq;
+    $vallen = length $val;
+    print $sock_m1 "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m1>, "STORED\r\n", "stored");
+}
+
+# release second process
+kill 'CONT', $m2->{pid} + 1;
+
+# wait for a while, as normal sync time may not be enough
+sleep(10);
+
+mem_get_is($sock_m1, $key, $val, "get $key from 1st");
+mem_get_is($sock_m2, $key, $val, "get $key from 2nd");
+
+# another item; it should push everything if not yet
+
+$uniq = int(rand()*100000);
+$key = 'settest_1_fini';
+$val = 'setval' . ('0' x 1024) . $uniq;
+$vallen = length $val;
+print $sock_m1 "set $key 0 0 $vallen\r\n$val\r\n";
+is(scalar <$sock_m1>, "STORED\r\n", "stored");
+
+sleep(1);
+
+mem_get_is($sock_m1, $key, $val, "get $key from 1st");
+mem_get_is($sock_m2, $key, $val, "get $key from 2nd");
diff -urN memcached-1.4.13/t.rep/README memcached-1.4.13-repcached-2.3.1/t.rep/README
--- memcached-1.4.13/t.rep/README	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/README	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,4 @@
+./configure --enable-replication
+make
+make test
+prove t.rep
diff -urN memcached-1.4.13/t.rep/lib/RepcachedTest.pm memcached-1.4.13-repcached-2.3.1/t.rep/lib/RepcachedTest.pm
--- memcached-1.4.13/t.rep/lib/RepcachedTest.pm	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/lib/RepcachedTest.pm	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,30 @@
+package RepcachedTest;
+use strict;
+use warnings;
+use Carp;
+use MemcachedTest;
+use base qw(MemcachedTest);
+use Exporter qw(import);
+our @EXPORT = (@MemcachedTest::EXPORT,
+               qw(new_repcached sync_get_is
+                ));
+use Time::HiRes;
+
+our $REP_LAG = 0.8;
+
+sub new_repcached() {
+    my ($port_master,$port_backup,$port_rep) = (free_port(),free_port(),free_port());
+    return (
+        new_memcached("-l 127.0.0.1 -x 127.0.0.1 -X $port_rep -q 65536", $port_master),
+        new_memcached("-l 127.0.0.1 -x 127.0.0.1 -X $port_rep -q 65536", $port_backup),
+       );
+}
+
+sub sync_get_is {
+    my($sock_m,$sock_b) = (shift, shift);
+    mem_get_is($sock_m, @_);
+    Time::HiRes::sleep $REP_LAG;
+    mem_get_is($sock_b, @_);
+}
+
+1;
diff -urN memcached-1.4.13/testapp.c memcached-1.4.13-repcached-2.3.1/testapp.c
--- memcached-1.4.13/testapp.c	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/testapp.c	Mon Feb 13 01:13:58 2012
@@ -338,6 +338,10 @@
         argv[arg++] = "-1";
         argv[arg++] = "-U";
         argv[arg++] = "0";
+#ifdef USE_REPLICATION
+        argv[arg++] = "-X";
+        argv[arg++] = "0";
+#endif
         /* Handle rpmbuild and the like doing this as root */
         if (getuid() == 0) {
             argv[arg++] = "-u";
